package com.javacodegeeks;

import java.util.Stack;

import org.junit.Assert;
import org.junit.Test;
import org.mockito.Mockito;

public class MockitoExample {
	
	@Test
	public void verify() {
		// Create Mock
		Stack<String> mockStack = Mockito.mock(Stack.class);
		// Use mock object
		mockStack.add("Test verify");
		Mockito.verify(mockStack).add("Test verify");		
	}
	
	@Test
	public void stub() {
		// Create Mock
		Stack<String> mockStack = Mockito.mock(Stack.class);
		Assert.assertEquals(mockStack.capacity(), 0);
		// Stub
		Mockito.when(mockStack.capacity()).thenReturn(10);
		Assert.assertEquals(mockStack.capacity(), 10);
		Mockito.verify(mockStack, Mockito.times(2)).capacity();	
	}
	
	@Test
	public void argumentMatcher() {
		Stack<String> mockStack = Mockito.mock(Stack.class);
		Mockito.when(mockStack.get(Mockito.anyInt())).thenReturn("PASS");
		Assert.assertEquals(mockStack.get(0), "PASS");
		Assert.assertEquals(mockStack.get(10), "PASS");
		Mockito.verify(mockStack, Mockito.times(2)).get(Mockito.anyInt());
	}

}
